// OTT mirror
// Copyright (C) 2014 Balthasar Szczepański
// bot3.cpp (bothasar_p)
// the post bot.
// 12.09.2014
//
// This file is part of OTT mirror.
//
// OTT mirror is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affreo General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// OTT mirror is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affreo General Public License for more details.
// 
// You should have received a copy of the GNU Affreo General Public License
// along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/wait.h>

#define OK              0
#define POST_MSTD     256
#define INDELIVERABLE 512
#define NOPOSTS         3
#define STOP_MSTD       4
#define NAME_MSTD       5

###USERAGENT3
###NAME_PATH
###LASTTIME_PATH
###LOG_PATH3
###TEMPFILE_PATH
###POSTDATA_PATH
###COOKIE_PATH
###STOP_PATH3
###POST_PATH3
###LIST_PATH3
###LAST_PATH3
###IND_PATH3
###OK_PATH3
###PM_PATH3
###FAIL_PATH3

###WGET_PATH
###MAWK_PATH
###RM_PATH
###MV_PATH
###AWK_POST
###AWK_PM

FILE *cwfile;
FILE *stopfile;
FILE *listfile;
bool listopen=false;
bool logopen=false;
pid_t sub;
int r;

int main(int argc, char *argv[]);
void end(int m);

int main(int argc, char *argv[])
{
	time_t t;
	
	int yarg;
	
	bool fm=false;
	bool fw=false;
	
	bool newlog=false;
	bool text=false;
	
	unsigned long max=0xffffffff;
	// unsigned long posts=0xffffffff;
	unsigned long pwait=5;
	
	unsigned long np, lastnp, firstnp, i;
	unsigned short p, lastp, firstp;
	
	char name[256];
	char pass[256];
	char listpath[256];
	char postpath[256];
	char postname[256];
	char argp1  [256];
	char argp2[256];
	char argp3[256];
	char argp4[256];
	char argp5[256];
	
	time(&t);
	opterr=0;
	
	//t -nolog
	//n -newlog
	//w -wait
	//m -maxposts
	
	while((yarg = getopt(argc,argv,"m:w:nt")) != -1)
	{
		switch(yarg)
		{
		case 'm':
			fm=true;
			if(optarg!=NULL)
				sscanf(optarg,"%lu",&max);
			break;
		case 'w':
			fw=true;
			if(optarg!=NULL)
				sscanf(optarg,"%lu",&pwait);
			break;
		case 'n':
			newlog=true;
			break;
		case 't':
			text=true;
			break;
		default:
			
			break;
		}
	}
	
	if(!fm)
		max=0xffffffff;
	if(!fw)
		pwait=15;
	if(!text)
	{
		if(freopen(LOG_PATH,newlog?"wt":"at",stdout)!=NULL)
			logopen=true;
	}

	setvbuf(stdout, NULL, _IONBF, 0);
	dup2(fileno(stdout),fileno(stderr));
	printf("\n%s",ctime(&t));
	printf("max=%lu, P wait=%lus",max,pwait);
	
	
	stopfile=fopen(STOP_PATH,"wt");
	if (stopfile==NULL)
		end(STOP_MSTD);
	if (lockf(fileno(stopfile),F_TLOCK,0)!=0)
		end(STOP_MSTD);	
	fprintf(stopfile,"%hu.FULL STOPFULL STOP\n",0);
	
	cwfile=fopen(NAME_PATH,"rt");
	if(cwfile==NULL)
		end(NAME_MSTD);
	if(fgets(argp1,255,cwfile)!=NULL)
		sscanf(argp1,"%s",name);
	else
		end(NAME_MSTD);
	if(fgets(argp1,255,cwfile)!=NULL)
		sscanf(argp1,"%s",pass);
	else
		end(NAME_MSTD);
	fclose(cwfile);
	
	cwfile=fopen(LAST_PATH,"rt");
	if(cwfile==NULL)
		end(NOPOSTS);
	if(fgets(argp1,255,cwfile)!=NULL)
		sscanf(argp1,"%lu",&lastnp);
	else
		end(NOPOSTS);
	if(fgets(argp1,255,cwfile)!=NULL)
		sscanf(argp1,"%hu",&lastp);
	else
		end(NOPOSTS);
	fclose(cwfile);
	
	printf(". Last page: %lu with last post %hu",lastnp,lastp);
	
	cwfile=fopen(LASTTIME_PATH,"rt");
	if(cwfile==NULL)
	{
		firstnp=1;
		firstp=0;
	}
	else
	{
		if(fgets(argp1,255,cwfile)!=NULL)
		{
			sscanf(argp1,"%lu",&firstnp);
			if(fgets(argp1,255,cwfile)!=NULL)
				sscanf(argp1,"%hu",&firstp);
			else
				firstp=0;
		}
		else
		{
			firstnp=1;
			firstp=0;
		}
		
		fclose(cwfile);
	}
	printf(" Start after np %lu, post %hu.",firstnp,firstp);
	for(i=0,np=firstnp;np<=lastnp;++np)
	{
		p=0;
		printf("\nnp%lu:",np);
		
		sprintf(listpath,"%s%lu",LIST_PATH,np);
		listfile=fopen(listpath,"rt");
		if(listfile==NULL)
		{
			printf("\nNo posts.");
			continue;
		}
		listopen=true;
		
		for(p=1;fgets(argp1,255,listfile)!=NULL;++p)
		{
			if((np==firstnp&&p<=firstp)||(np==lastnp&&p>lastp))
				continue;
			if(np!=firstnp||p!=firstp+1)
				sleep(pwait);
			sscanf(argp1,"%s",postname);
			printf("\n%hu: m%s: ",p,postname);
			
			sprintf(postpath,"%s%s",POST_PATH,postname);
			sprintf(argp1 ,"postfile=%s",POSTDATA_PATH);
			sprintf(argp2,"cookiefile=%s",COOKIE_PATH);
			sprintf(argp3,"tempfile=%s",TEMPFILE_PATH);
			sprintf(argp4,"name=%s",name);
			sprintf(argp5,"pass=%s",pass);
			
			sub=fork();
			if(!sub)
			{
				r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_POST,"-v",argp1,"-v",argp2,"-v",argp3,postpath,(char *)0);
				exit(r);
			}
			waitpid(sub,&r,0);
			switch(r)
			{
			case POST_MSTD:
				end(POST_MSTD);
				break;
			case OK:
				printf("Ok.");
				cwfile=fopen(LASTTIME_PATH,"wt");
				if(cwfile==NULL)
				{
					printf("\nCAN'T SAVE PROGRESS: NP%lu P%hu",np,p);
					end(STOP_MSTD);
				}
				fprintf(cwfile,"%lu\n%hu\n",np,p);
				fclose(cwfile);
				sub=fork();
				if(!sub)
				{
					r=execl(MV_PATH,MV_PATH,postpath,OK_PATH,(char *)0);
					exit(r);
				}
				waitpid(sub,&r,0);
				break;
			case INDELIVERABLE:
			default:
				sleep(pwait);
				printf("send a PM: ");
				sub=fork();
				if(!sub)
				{
					r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_PM,"-v",argp1,"-v",argp2,"-v",argp3,"-v",argp4,"-v",argp5,postpath,(char *)0);
					exit(r);
				}
				waitpid(sub,&r,0);
				switch(r)
				{
				case POST_MSTD:
					end(POST_MSTD);
					break;
				case OK:
					printf("Ok.");
					cwfile=fopen(LASTTIME_PATH,"wt");
					if(cwfile==NULL)
					{
						printf("\nCAN'T SAVE PROGRESS: NP%lu P%hu",np,p);
						end(STOP_MSTD);
					}
					fprintf(cwfile,"%lu\n%hu\n",np,p);
					fclose(cwfile);
					sub=fork();
					if(!sub)
					{
						r=execl(MV_PATH,MV_PATH,postpath,PM_PATH,(char *)0);
						exit(r);
					}
					waitpid(sub,&r,0);
					break;
				case INDELIVERABLE:
				default:
					printf("Indeliverable.");
					cwfile=fopen(LASTTIME_PATH,"wt");
					if(cwfile==NULL)
					{
						printf("\nCAN'T SAVE PROGRESS: NP%lu P%hu",np,p);
						end(STOP_MSTD);
					}
					fprintf(cwfile,"%lu\n%hu\n",np,p);
					fclose(cwfile);
					sub=fork();
					if(!sub)
					{
						r=execl(MV_PATH,MV_PATH,postpath,FAIL_PATH,(char *)0);
						exit(r);
					}
					waitpid(sub,&r,0);
					break;
				}
				break;
			}
			
		}
		listopen=false;
		fclose(listfile);
		if(np<lastnp)
		{
			sub=fork();
			if(!sub)
			{
				r=execl(RM_PATH,RM_PATH,"-f",listpath,(char *)0);
				exit(r);
			}
			waitpid(sub,&r,0);
		}
	}
	
	cwfile=fopen(LAST_PATH,"rt");
	if(cwfile!=NULL)
	{
		if(fgets(argp1,255,cwfile)!=NULL)
		{
			sscanf(argp1,"%lu",&np);
			if(fgets(argp1,255,cwfile)!=NULL)
			{
				sscanf(argp1,"%hu",&p);
				fclose(cwfile);
				if(np==lastnp&&p==lastp)
				{
					sub=fork();
					if(!sub)
					{
						r=execl(RM_PATH,RM_PATH,"-f",LAST_PATH,(char *)0);
						exit(r);
					}
					waitpid(sub,&r,0);
					
					sub=fork();
					if(!sub)
					{
						r=execl(RM_PATH,RM_PATH,"-f",LASTTIME_PATH,(char *)0);
						exit(r);
					}
					waitpid(sub,&r,0);
					
					sub=fork();
					if(!sub)
					{
						r=execl(RM_PATH,RM_PATH,"-f",listpath,(char *)0);
						exit(r);
					}
					waitpid(sub,&r,0);
					
					sub=fork();
					if(!sub)
					{
						r=execl(RM_PATH,RM_PATH,"-f",IND_PATH,(char *)0);
						exit(r);
					}
					waitpid(sub,&r,0);
					
					printf("\nEverything posted");
					end(OK);
				}
			}
			else
				fclose(cwfile);
		}
		else
			fclose(cwfile);
	}
	printf("\nNew posts appeared, left for next time.");
	end(OK);
}

void end(int m)
{
	switch(m)
	{
	case NAME_MSTD:
		printf("\nName and password fail.\n");
		break;
	case STOP_MSTD:
		printf("\nFULL STOPFULL STOP\n");
		break;
	case POST_MSTD:
		printf("\nMustard.\n");
		break;
	case NOPOSTS:
		printf("\nNo posts.\n");
		break;
	
	case OK:
		printf("\nOK\n");
		break;
	default:
		printf("\nCh*rping m*stard!\n");
	}
	if(logopen)
		fclose(stdout);
	if(listopen)
		fclose(listfile);
	if(m != STOP_MSTD)
	{
		sub=fork();
		if(!sub)
		{
			r=execl(RM_PATH,RM_PATH,"-f",COOKIE_PATH,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		sub=fork();
		if(!sub)
		{
			r=execl(RM_PATH,RM_PATH,"-f",POSTDATA_PATH,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		sub=fork();
		if(!sub)
		{
			r=execl(RM_PATH,RM_PATH,"-f",TEMPFILE_PATH,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		
		lockf(fileno(stopfile),F_ULOCK,0);
		fclose(stopfile);
		
		sub=fork();
		if(!sub)
		{
			r=execl(RM_PATH,RM_PATH,"-f",STOP_PATH,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		
	}
	exit(m);
}