// OTT mirror
// Copyright (C) 2014 Balthasar Szczepański
// image.cpp
// recognize image format.
// 12.09.2014
//
// This file is part of OTT mirror.
//
// OTT mirror is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affreo General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// OTT mirror is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affreo General Public License for more details.
// 
// You should have received a copy of the GNU Affreo General Public License
// along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

#define NO_IDEA 0
#define GIF     1
#define PNG     2
#define JPG     3
#define BMP     4

#define MAGIC_BMP  "\x42\x4d"
#define MAGIC_JPG  "\xff\xd8\xff"
#define MAGIC_PNG  "\x89\x50\x4e\x47\x0d\x0a\x1a\x0a"
#define MAGIC_GIF7 "\x47\x49\x46\x38\x37\x61"
#define MAGIC_GIF9 "\x47\x49\x46\x38\x39\x61"

#include <stdio.h>
#include <string.h>

int main (int argc, char **argv)
{
	FILE *file;
	char test[9];
	if (argc<2)
		return NO_IDEA;
	
	file=fopen(argv[1],"rb");
	if(file==NULL)
		return NO_IDEA;
	
	fread(test,1,8,file);
	fclose(file);
	
	test[8]='\0';
	if(strcmp(test,MAGIC_PNG)==0)
		return PNG;
	test[6]='\0';
	if(strcmp(test,MAGIC_GIF7)==0)
		return GIF;
	if(strcmp(test,MAGIC_GIF9)==0)
		return GIF;
	test[3]='\0';
	if(strcmp(test,MAGIC_JPG)==0)
		return JPG;
	test[2]='\0';
	if(strcmp(test,MAGIC_BMP)==0)
		return BMP;
	return NO_IDEA;
}