// OTT mirror
// Copyright (C) 2014 Balthasar Szczepański
// mpview.cpp
// view a post from the mirror.
// 02.09.2014
//
// This file is part of OTT mirror.
//
// OTT mirror is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affreo General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// OTT mirror is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affreo General Public License for more details.
// 
// You should have received a copy of the GNU Affreo General Public License
// along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

#include <cgi.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

###RM_PATH
###CAT_PATH
###MAWK_PATH

###NP_TOP_PATH
###NP_END_PATH
###INFO_PATH
###POST_PATH3
###OK_PATH3
###PM_PATH3
###FAIL_PATH3
// ###POSTLIST_PATH3
// ###LAST_PATH3

###AWK_VIEW
###AWK_MVIEW
###TEMP_PATHm

int main()
{
	s_cgi *cgi;
	pid_t sub;
	int r;
	
	char line[32];
	char filename[32];
	char postpath[256];
	char cat[8];
	
	char *arg;
	
	char path2[256];
	char left[256];
	char right[256];
	char links[256];
	
	cgi=cgiInit();
	
	printf("Content-type: text/html\n\n");
	
	arg=cgiGetValue(cgi,"v");
	sprintf(line,"%s",arg?arg:"???");
	if(line[0]=='m')
	{
		sprintf(filename,"%s",line+1);
		sprintf(cat,"t=%s","m");
		sprintf(postpath,"%s%s",POST_PATH,filename);
	}
	else if(line[0]=='o' && line[1]=='k')
	{
		sprintf(filename,"%s",line+2);
		sprintf(cat,"cat=%s","ok");
		sprintf(postpath,"%s%s",OK_PATH,filename);
	}
	else if(line[0]=='p' && line[1]=='m')
	{
		sprintf(filename,"%s",line+2);
		sprintf(cat,"cat=%s","pm");
		sprintf(postpath,"%s%s",PM_PATH,filename);
	}
	else if(line[0]=='f' && line[1]=='l')
	{
		sprintf(filename,"%s",line+2);
		sprintf(cat,"cat=%s","fl");
		sprintf(postpath,"%s%s",FAIL_PATH,filename);
	}
	else 
	{
		sprintf(filename,"%s","???");
		sprintf(postpath,"%s","???");
		sprintf(cat,"cat=%s","???");
	}
	
	
	sprintf(right,"%s","right=<!-- -->");
	
	sprintf(left,"%s","left=<!-- -->");
	
	sprintf(path2,"%s%lu",TEMP_PATH,(unsigned long)getpid());
	sprintf(links,"%s","links=<!-- -->");
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_VIEW,"-v",left,"-v",right,"-v",links,"-v","title=<h2><a href=\"/ott/posted\" >Posted from the ЯOЯЯIM TTO</a></h2>",NP_TOP_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<p>Ch*rpin* M*stard</p>");
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_MVIEW,"-v","bg=1","-v",cat,"-v","s=1",postpath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
	{
		printf("<div id=\"%s\" class=\"post bg1\">\n",line);
		printf("<div class=\"inner\"><span class=\"corners-top\"><span></span></span>\n");
		printf("POST NOT FOUND.\n");
		printf("<span class=\"corners-bottom\"><span></span></span>\n</div></div>\n");
		printf("<hr class=\"divider\"></hr>\n");
	}
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_VIEW,"-v",left,"-v",right,"-v",links,NP_END_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<p>Ch*rpin* M*stard</p>");
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(RM_PATH,RM_PATH,"-f",path2,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<p>Ch*rpin* M*stard! file not deleted!</p>");
	
	return 0;
}
