// OTT mirror
// Copyright (C) 2014 Balthasar Szczepański
// mview.cpp
// view posts from the mirror.
// 12.09.2014
//
// This file is part of OTT mirror.
//
// OTT mirror is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affreo General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// OTT mirror is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affreo General Public License for more details.
// 
// You should have received a copy of the GNU Affreo General Public License
// along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

#include <cgi.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

###RM_PATH
###CAT_PATH
###MAWK_PATH

###NP_TOP_PATH
###NP_END_PATH
###INFO_PATH
###POST_PATH3
###POSTLIST_PATH3
###LAST_PATH3

###AWK_VIEW
###AWK_MVIEW
###TEMP_PATH3v

unsigned long p2np(unsigned long p)
{
	FILE *file;
	char path[256];
	char text[256];
	unsigned long np=0;
	unsigned long np2;
	unsigned long pp;
	
	for(short i=31;i>=0;--i)
	{
		np2 = np + (1L << i);
		sprintf(path,"%s%lu",POSTLIST_PATH,np2);
		file=fopen(path,"rt");
		if(file==NULL)
			continue;
		fgets(text,255,file);
		fclose(file);
		sscanf(text,"%lu",&pp);
		if(pp==p)
			return np2;
		else if(pp<p)
			np=np2;
	}
	if(np==0)
		return 1L;
	sprintf(path,"%s%lu",POSTLIST_PATH,np);
	file=fopen(path,"rt");
	if(file==NULL)
		return 1L;
	while(fgets(text,255,file)!=NULL)
	{
		sscanf(text,"%lu",&pp);
		if(pp==p)
			return np;
	}
	fclose(file);
	--np;
	sprintf(path,"%s%lu",POSTLIST_PATH,np);
	file=fopen(path,"rt");
	if(file==NULL)
		return 1L;
	while(fgets(text,255,file)!=NULL)
	{
		sscanf(text,"%lu",&pp);
		if(pp==p)
			return np;
	}
	return 1L;
}
int main()
{
	s_cgi *cgi;
	pid_t sub;
	int r;
	
	char *arg;
	char path[256];
	char bg[16];
	char page[16];
	char path2[256];
	char left[256];
	char right[256];
	char links[256];
	FILE *file;
	unsigned long np=1L;
	unsigned long start=0L;
	unsigned long p=0L;
	unsigned long last=0xffffffff;
	unsigned long ps=0xffffffff;
	
	cgi=cgiInit();
	
	file = fopen(LAST_PATH,"rt");
	if(file!=NULL)
	{
		fscanf(file,"%lu",&last);
		fscanf(file,"%lu",&ps);
		fclose(file);
		ps=(last-1)*40+ps;
	}
	else
	{
		printf("Content-type: text/html\nStatus: 404 Not Found\n\n");
		sprintf(path,"info=<p>There are no posts in this Otherthread.<br /><br /><a href=\"/ott/\">Return to the ЯOЯЯIM TTO</a></p>");
		
		fflush(stdout);
		sub=fork();
		if(sub==0)
		{
			r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_VIEW,"-v",path,INFO_PATH,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		if(r)
			printf("<HTML><body>%s</body></html>",path);
		return 0;
	}
	
	printf("Content-type: text/html\n\n");
	
	arg=cgiGetValue(cgi,"np");
	if(arg!=NULL)
		sscanf(arg,"%lu",&np);
	else
	{
		arg=cgiGetValue(cgi,"start");
		if(arg!=NULL)
		{
			sscanf(arg,"%lu",&start);
			np=start/40L+1L;
		}
		else
		{
			arg=cgiGetValue(cgi,"p");
			if(arg!=NULL)
			{
				sscanf(arg,"%lu",&p);
				np=p2np(p);//not really
			}
			else
				np=1L;
		}
	}
	if(np>last)
		np=last;
	if(np<last)
		sprintf(right,"right=<a href=\\\"/ott/mview?np=%lu\\\" class=\\\"right-box right\\\" >Next</a>",np+1);
	else
		sprintf(right,"%s","right=<!-- -->");
	if(np>1)
		sprintf(left,"left=<a href=\\\"/ott/mview?np=%lu\\\" class=\\\"left-box left\\\" >Previous</a>",np-1);
	else
		sprintf(left,"%s","left=<!-- -->");
	
	sprintf(path2,"%s%lu",TEMP_PATH,(unsigned long)getpid());
	sprintf(links,"links=%s",path2);
	file=fopen(path2,"wt");
	if(file!=NULL)
	{
		fprintf(file,"<div class=\"pagination\" >\n");
		fprintf(file,"%lu posts\n",ps);
		fprintf(file,"&bull; <a href=\"#\" onclick=\"jumpto(); return false;\" title=\"Click to jump to page…\" >");
		fprintf(file,"Page <strong>%lu</strong> of <strong>%lu</strong></a>  &bull; <span>",np,last);
		if(np>1)
		{
			fprintf(file,"<a href=\"/ott/mview?np=1\" >1</a>");
			fprintf(file,(np>6)?"<span class=\"page-dots\" > ... </span>":"<span class=\"page-sep\" >, </span>");
		}
		for(unsigned long i=((np>6)?((np<last)?(np-3):(np-4)):2);i<np;++i)
			fprintf(file,"<a href=\"/ott/mview?np=%lu\" >%lu</a><span class=\"page-sep\" >, </span>",i,i);
		fprintf(file,"<strong>%lu</strong>",np);
		for(unsigned long i=np+1;i<=((np+6<=last)?((np==1)?(np+4):(np+3)):(last-1));++i)
			fprintf(file,"<span class=\"page-sep\" >, </span><a href=\"/ott/mview?np=%lu\" >%lu</a>",i,i);
		if(np<last)
		{
			fprintf(file,(np+6<=last)?"<span class=\"page-dots\" > ... </span>":"<span class=\"page-sep\" >, </span>");
			fprintf(file,"<a href=\"/ott/mview?np=%lu\" >%lu</a>",last,last);
		}
		fprintf(file,"</span>\n</div>\n");
		fclose(file);
	}
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_VIEW,"-v",left,"-v",right,"-v",links,"-v","title=<h2><a href=\"/ott/mview?np=1\" >Mustardtime Otherthread</a></h2>",NP_TOP_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<p>Ch*rpin* M*stard</p>");
		
	sprintf(path2,"%s%lu",POSTLIST_PATH,np);
	file=fopen(path2,"rt");
	if(file!=NULL)
	{
		for(unsigned short i=0;fgets(path,255,file)!=NULL;++i)
		{
			sscanf(path,"%s",path2);
			sprintf(path,"%s%s",POST_PATH,path2);
			sprintf(bg,"bg=%hu",2-(i&1));
			sprintf(page,"np=%lu",np);
			
			fflush(stdout);
			sub=fork();
			if(sub==0)
			{
				r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_MVIEW,"-v",bg,"-v",page,"-v","cat=m",path,(char *)0);
				exit(r);
			}
			waitpid(sub,&r,0);
			if(r)
			{
				printf("<div id=\"m%s\" class=\"post bg%hu\">\n",path2,2-(i&1));
				printf("<div class=\"inner\"><span class=\"corners-top\"><span></span></span>\n");
				printf("%hu: POST NOT FOUND.\n",i);
				printf("<span class=\"corners-bottom\"><span></span></span>\n</div></div>\n");
				printf("<hr class=\"divider\"></hr>\n");
			}
		}
		fclose(file);
	}
	else
	{
		printf("<div id=\"m%lu\" class=\"post bg2\">\n",np);
		printf("<div class=\"inner\"><span class=\"corners-top\"><span></span></span>\n");
		printf("PAGE NOT FOUND.\n");
		printf("<span class=\"corners-bottom\"><span></span></span>\n</div></div>\n");
		printf("<hr class=\"divider\"></hr>\n");
	}
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_VIEW,"-v",left,"-v",right,"-v",links,NP_END_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<p>Ch*rpin* M*stard</p>");
	
	sprintf(path2,"%s%lu",TEMP_PATH,(unsigned long)getpid());
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(RM_PATH,RM_PATH,"-f",path2,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<p>Ch*rpin* M*stard! file not deleted!</p>");
	
	return 0;
}
