// OTT mirror
// Copyright (C) 2014 Balthasar Szczepański
// posted.cpp
// posts recently sent from the mirror.
// 23.11.2014
//
// This file is part of OTT mirror.
//
// OTT mirror is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affreo General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// OTT mirror is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affreo General Public License for more details.
// 
// You should have received a copy of the GNU Affreo General Public License
// along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

#include <cgi.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
// #include <string.h>
#include <sys/wait.h>

###TEMP_PATHr
###OK_PATH3
###PM_PATH3
###FAIL_PATH3
###LS_PATH
###RM_PATH
###MAWK_PATH
###AWK_POSTED

s_cgi *cgi;
pid_t sub;
int r;


int main(int argc, char **argv)
{
	char temppath[256]="";
	char line[32];
	char filename[32];
	char postpath[256];
	FILE *tempfile;
	FILE *postfile;
	
	
	// dup2(fileno(stdout),fileno(stderr));
	cgi=cgiInit();
	
	sprintf(temppath,"%s%lu",TEMP_PATH,(unsigned long)getpid());
	
	printf("Content-type: text/html\n\n");
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"\">\n");
	printf("<html lang=\"en\"><head>\n");
	printf("<title>Posted &bull; ЯOЯЯIM TTO &bull; Bicycles on the Moon</title>\n");
	printf("<meta http-equiv=\"Content-type\" content=\"text/html; charset=UTF-8\">\n");
	printf("<link rel=\"icon\" type=\"image/png\" href=\"/img/favicon.png\">\n");
	printf("<link rel=\"stylesheet\" href=\"/css/botm.css\">\n");
	printf("</head><body><a href=\"/\"><img src=\"/img/botmlogo2.png\" alt=\"1190.bicyclesonthemoon.info\" border=\"0\"></a>\n");
	printf("<h1>Posted from the ЯOЯЯIM TTO</h1>\n");
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		if(freopen(temppath,"wt",stdout)==NULL)
			exit(255);
		r=execl(LS_PATH,LS_PATH,"-1","--color=never",FAIL_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("No posts in the FAIL category.<br>\n");
	else
	{
		printf("<table class=\"pl\"><tr class=\"pls\"><td colspan=\"4\">FAIL</td></tr>\n");
		printf("<tr class=\"plt\"><td class=\"plk\">time</td><td class=\"plk\">author</td><td class=\"plk\">subject</td><td class=\"plk\">action</td></tr>\n");
		
		tempfile=fopen(temppath,"rt");
		if(tempfile!=NULL)
		{
			for(unsigned char i=0; fgets(line,31,tempfile)!=NULL; ++i)
			{
				sscanf(line,"%s",filename);
				sprintf(postpath,"%s%s",FAIL_PATH,filename);
				
				fflush(stdout);
				sub=fork();
				if(!sub)
				{
					r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_POSTED,"-v",i&0x1?"r2=1":"r2=0","-v","cat=fl",postpath,(char *)0);
					exit(r);
				}
				waitpid(sub,&r,0);
				
			}
			fclose(tempfile);
		}
		
		printf("</table><br>\n");
	}
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		if(freopen(temppath,"wt",stdout)==NULL)
			exit(255);
		r=execl(LS_PATH,LS_PATH,"-1","--color=never",PM_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("No posts in the PM category.<br>\n");
	else
	{
		printf("<table class=\"pl\"><tr class=\"pls\"><td colspan=\"4\">PM</td></tr>\n");
		printf("<tr class=\"plt\"><td class=\"plk\">time</td><td class=\"plk\">author</td><td class=\"plk\">subject</td><td class=\"plk\">action</td></tr>\n");
		
		tempfile=fopen(temppath,"rt");
		if(tempfile!=NULL)
		{
			for(unsigned char i=0; fgets(line,31,tempfile)!=NULL; ++i)
			{
				sscanf(line,"%s",filename);
				sprintf(postpath,"%s%s",PM_PATH,filename);
				
				fflush(stdout);
				sub=fork();
				if(!sub)
				{
					r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_POSTED,"-v",i&0x1?"r2=1":"r2=0","-v","cat=pm",postpath,(char *)0);
					exit(r);
				}
				waitpid(sub,&r,0);
				
			}
			fclose(tempfile);
		}
		
		printf("</table><br>\n");
	}
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		if(freopen(temppath,"wt",stdout)==NULL)
			exit(255);
		r=execl(LS_PATH,LS_PATH,"-1","--color=never",OK_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("No posts in the OK category.<br>\n");
	else
	{
		printf("<table class=\"pl\"><tr class=\"pls\"><td colspan=\"4\">OK</td></tr>\n");
		printf("<tr class=\"plt\"><td class=\"plk\">time</td><td class=\"plk\">author</td><td class=\"plk\">subject</td><td class=\"plk\">action</td></tr>\n");
		
		tempfile=fopen(temppath,"rt");
		if(tempfile!=NULL)
		{
			for(unsigned char i=0; fgets(line,31,tempfile)!=NULL; ++i)
			{
				sscanf(line,"%s",filename);
				sprintf(postpath,"%s%s",OK_PATH,filename);
				
				fflush(stdout);
				sub=fork();
				if(!sub)
				{
					r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_POSTED,"-v",i&0x1?"r2=1":"r2=0","-v","cat=ok",postpath,(char *)0);
					exit(r);
				}
				waitpid(sub,&r,0);
				
			}
			fclose(tempfile);
		}
		
		printf("</table><br>\n");
	}
	printf("<a href=\"/ott\">back to the ЯOЯЯIM TTO</a><br><br>\n");
	printf("<a href=\"/\">1190.bicyclesonthemoon.info</a></body></html>\n");
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(RM_PATH,RM_PATH,"-f",temppath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	
	return 0;
}

